/*
 * Copyright (c) 2012 Citrix Systems, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef UI_XEN_INPUT_H_
# define UI_XEN_INPUT_H_

# include "hw/xen/xen-dmbus.h"

void xen_input_init(void);
void xen_input_deinit(void);
void xen_input_abs_enabled(int enabled);

typedef void (*xen_input_direct_event_cb_t)(void *opaque,
                                            uint16_t type,
                                            uint16_t code,
                                            int32_t value);
typedef void (*xen_input_set_slot_cb_t)(void *opaque, uint8_t slot);
typedef void (*xen_input_config_cb_t)(void *opaque, InputConfig *c);
typedef void (*xen_input_config_reset_cb_t)(void *opaque, uint8_t slot);


void xen_input_set_direct_event_handler(xen_input_direct_event_cb_t handler,
                                        void *opaque);

/* This function is ugly but I have no idea to avoid some xenmou code in input
 * file */
void xen_input_set_handlers(xen_input_set_slot_cb_t slot_handler,
                            xen_input_config_cb_t config_handler,
                            xen_input_config_reset_cb_t config_reset_handler,
                            void *opaque);

int32_t xen_input_send_shutdown(int32_t reason);

#endif /* !UI_XEN_INPUT_H_ */
